﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Configuration;
using System.Data.SqlClient;

namespace CollationDemoWinForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Bind the DataGridView to the BindingSource 
            // and load the data from the database.
            dataGridView1.DataSource = bindingSource1;
            GetData("SELECT * FROM [Demo].[Person] WHERE [PersonID] >= 100000 ORDER BY [LastName] ASC");
            dataGridView1.AutoResizeColumn(0);
            dataGridView1.AutoResizeColumn(1);
            dataGridView1.AutoResizeColumn(2);
            
        }

        private void GetData(string selectCommand)
        {
            try
            {
                // Specify a connection string. Replace the given value with a  
                // valid connection string for a Northwind SQL Server sample 
                // database accessible to your system.
                string connectionString = ConfigurationManager.ConnectionStrings["SQLConn"].ConnectionString;

                // Create a new data adapter based on the specified query.
                SqlDataAdapter adapter  = new SqlDataAdapter(selectCommand, connectionString);

                // Create a command builder to generate SQL update, insert, and 
                // delete commands based on selectCommand. These are used to 
                // update the database.
                SqlCommandBuilder commandBuilder = new SqlCommandBuilder(adapter);

                // Populate a new data table and bind it to the BindingSource.
                DataTable table = new DataTable();
                table.Locale = System.Globalization.CultureInfo.InvariantCulture;
                adapter.Fill(table);
                bindingSource1.DataSource = table;

                // Resize the DataGridView columns to fit the newly loaded content.
                dataGridView1.AutoResizeColumns(
                    DataGridViewAutoSizeColumnsMode.AllCellsExceptHeader);
            }
            catch (SqlException ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            dataGridView1.DataSource = bindingSource1;
            //DO NOT USE THIS WAY, SQL INJECTION MAY HAPPEN!!!! THIS IS FOR DEMO ONLY!!!
            
            
       
            //GetData(string.Format("SELECT * FROM [Demo].[Person] WHERE LastName LIKE '{0}%' AND [PersonID] >= 100000 ORDER BY [LastName] ASC", this.textBox1.Text));
            GetData(string.Format("SELECT * FROM [Demo].[Person] WHERE LastName COLLATE Hungarian_CI_AS LIKE '{0}%' AND [PersonID] >= 100000 ORDER BY [LastName] COLLATE Hungarian_CI_AS ASC", this.textBox1.Text));
            //GetData(string.Format("SELECT * FROM [Demo].[Person] WHERE LastName COLLATE Hungarian_Technical_CI_AS LIKE '{0}%' AND [PersonID] >= 100000 ORDER BY [LastName] COLLATE Hungarian_Technical_CI_AS ASC", this.textBox1.Text));

            dataGridView1.AutoResizeColumn(0);
            dataGridView1.AutoResizeColumn(1);
            dataGridView1.AutoResizeColumn(2);
        }
    }

    
}
