/*tempdb conflict*/
SELECT SERVERPROPERTY('Collation') --Latin1_General_CI_AS
GO
USE [master];
GO
IF DB_ID('TestCollationConflict') IS NOT NULL
BEGIN
ALTER DATABASE [TestCollationConflict] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
DROP DATABASE [TestCollationConflict];
END
GO
CREATE DATABASE [TestCollationConflict] COLLATE Hungarian_CI_AS;
GO
USE [TestCollationConflict]
GO
CREATE TABLE [dbo].[Table1]
(
col1 char(1),
col2 int
);
GO
CREATE TABLE #LatinTable
(
col1 char(1),
col2 int
);
GO

INSERT INTO [dbo].[Table1] (col1, col2) VALUES 
('a',2), ('b',3), ('c',4);
INSERT INTO #LatinTable (col1, col2) VALUES 
('a',9), ('b',8), ('c',7);

SELECT
A.[col1],
B.[col2]
FROM
[dbo].[Table1] A
JOIN
#LatinTable B ON A.[col1] = B.[col1]
/*
Msg 468, Level 16, State 9, Line 38
Cannot resolve the collation conflict between "Latin1_General_CI_AS" and "Hungarian_CI_AS" in the equal to operation.
*/
--meta ellenrzs
SELECT DATABASEPROPERTYEX(DB_NAME(), 'Collation')
SELECT [name], [collation_name] FROM 
tempdb.sys.columns ao 
WHERE ao.[object_id] = 
(SELECT [object_id] FROM tempdb.sys.objects 
WHERE [name] LIKE '#LatinTable%')


SELECT
A.[col1],
B.[col2]
FROM
[dbo].[Table1] A
JOIN
#LatinTable B 
ON A.[col1] = B.[col1] COLLATE Latin1_General_CI_AS--Hungarian_CI_AS

/*msik opci*/
DROP TABLE #LatinTable;
GO
CREATE TABLE #LatinTable
(
col1 char(1) COLLATE DATABASE_DEFAULT,
col2 int
);
GO
INSERT INTO #LatinTable (col1, col2) VALUES 
('a',9), ('b',8), ('c',7);
GO

SELECT
A.[col1],
B.[col2]
FROM
[dbo].[Table1] A
JOIN
#LatinTable B ON A.[col1] = B.[col1]

--meta ellenrzs
SELECT DATABASEPROPERTYEX(DB_NAME(), 'Collation')
SELECT [name], [collation_name] FROM tempdb.sys.columns ao WHERE ao.[object_id] = (SELECT [object_id] FROM tempdb.sys.objects WHERE [name] LIKE '#LatinTable%')


/*cleanup*/
DROP TABLE #LatinTable;
GO
USE [master];
GO
IF DB_ID('TestCollationConflict') IS NOT NULL
BEGIN
ALTER DATABASE [TestCollationConflict] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
DROP DATABASE [TestCollationConflict];
END
GO


