USE [master];
GO
IF DB_ID('Test') IS NOT NULL
	BEGIN
		ALTER DATABASE [Test] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
		DROP DATABASE [Test];
	END
GO
CREATE DATABASE [Test] COLLATE Latin1_General_CI_AS;
GO
USE [Test]
GO


CREATE TABLE CollationTestTable
(
	[text] nvarchar(max)
)
GO

INSERT INTO [dbo].[CollationTestTable] ([text])
VALUES
(N'a'), (N'b'), (N'c'), (N'cukor'), (N'csupor'), (N'acl'), (N'lmos'), (N'acs'), (N'ax'), (N'zxxx')


SELECT [text] FROM [dbo].[CollationTestTable] ORDER BY [text] ASC --sorbarendezs a db collation szerint -->cukor, csupor
SELECT [text] FROM [dbo].[CollationTestTable] WHERE [text] LIKE '%' --accent sensitive
SELECT [text] FROM [dbo].[CollationTestTable] WHERE [text] LIKE 'c%' --cs bet is jn, mert ezzel a collation-nal nem szmt kln betnek!!!



----------------------------------------------------------------------------------------------------------------------
--ezek a magyar collation beltsok lehetsgesek:
SELECT * FROM sys.fn_helpcollations() fh WHERE name LIKE '%hungarian%'
----------------------------------------------------------------------------------------------------------------------
--Hungarian_Technical_CI_AS sorbarendezs
/*
sszettett bet (pl. cs) nem jl van rendezve, a csupor rtknek a cukor utn kellene jnnie, azonban az kezetes betket
az abc szerinti sorrendben kezeli pl, a, ..
*/
SELECT [text] FROM [dbo].[CollationTestTable] ORDER BY [text] COLLATE Hungarian_Technical_CI_AS ASC 

--Hungarian_Technical_CI_AS keress
/*
a LIKE 'c%' lehozza a CS betvel kezdd rtkeket is, pedig az egy kln bet
*/
SELECT [text] FROM [dbo].[CollationTestTable] WHERE [text] COLLATE Hungarian_Technical_CI_AS LIKE 'c%'
----------------------------------------------------------------------------------------------------------------------
--Hungarian_CI_AS sorbarendezs
/*
az kezesetes s nem kezetes betket egyenlknt kezeli,pl.: a = , de o <> , ezek kln betk,
azonban az sszetett betket helyesen kezeli: Cukor, Csupor
*/
SELECT [text] FROM [dbo].[CollationTestTable] ORDER BY [text] COLLATE Hungarian_CI_AS ASC

--Hungarian_CI_AS keress
/*
a LIKE 'c%' csak a c betvel kezddeket adja vissza, CS betvel kezdd rtkeket nem, mert az kln bet!
*/
SELECT [text] FROM [dbo].[CollationTestTable] WHERE [text] COLLATE Hungarian_CI_AS LIKE 'c%'

----------------------------------------------------------------------------------------------------------------------
--Latin1_General_CI_AS sorbarendezs
/*
az kezesetes s nem kezetes betket egyenlknt kezeli,pl.: a = , de o <> , ezek kln betk.
sszettett bet (pl. CS) nem jl van rendezve, a csupor rtknek a cukor utn kellene jnnie
*/

SELECT [text] FROM [dbo].[CollationTestTable] ORDER BY [text] COLLATE Latin1_General_CI_AS
--Hungarian_CI_AS keress
/*
az kezesetes s nem kezetes betket egyenlknt kezeli,pl.: a = , de o <> , ezek kln betk.
az sszetett betket nem kezeli, pl.: CS
*/
SELECT [text] FROM [dbo].[CollationTestTable] WHERE [text] COLLATE Latin1_General_CI_AS LIKE 'c%'

----------------------------------------------------------------------------------------------------------------------
--SQL_Hungarian_CP1250_CI_AS sorbarendezs
/*
az kezesetes s nem kezetes betket egyenlknt kezeli,pl.: a = , de o <> , ezek kln betk.
helyesen kezeli az sszetett betket: cukor utn csupor
*/
SELECT [text] FROM [dbo].[CollationTestTable] ORDER BY [text] COLLATE SQL_Hungarian_CP1250_CI_AS
--SQL_Hungarian_CP1250_CI_AS keress
/*
sszettett bet (pl. CS) nem kezeli
*/
SELECT [text] FROM [dbo].[CollationTestTable] WHERE [text] COLLATE SQL_Hungarian_CP1250_CI_AS LIKE 'c%'

