USE [master];
GO
EXEC sp_configure 'contained database authentication', 1;
RECONFIGURE WITH OVERRIDE;

GO
IF DB_ID('ContainedDb') IS NOT NULL
	BEGIN
		ALTER DATABASE [ContainedDb] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
		DROP DATABASE [ContainedDb];
	END
GO
CREATE DATABASE [ContainedDb] COLLATE Hungarian_CI_AS;
GO
ALTER DATABASE [ContainedDb] SET CONTAINMENT = PARTIAL WITH NO_WAIT
GO
ALTER DATABASE [ContainedDb] SET DEFAULT_LANGUAGE = 1038 WITH NO_WAIT
GO
USE [ContainedDb]
GO


SELECT DATABASEPROPERTYEX(DB_NAME(), 'Collation')
SELECT DISTINCT
	ao.[name] AS [object_name],
	c.[collation_name],
	ao.type, ao.type_desc 
FROM 
	sys.columns c 
JOIN	
	sys.all_objects ao ON ao.[object_id] = c.[object_id]
WHERE
	c.[collation_name] IS NOT NULL
AND	
	ao.[type] IN ('U', 'S')


--demo3 kd jrahasznlsa
CREATE TABLE [dbo].[Table1]
(
col1 char(1),
col2 int
);
GO
CREATE TABLE #LatinTable
(
col1 char(1),
col2 int
);
GO

INSERT INTO [dbo].[Table1] (col1, col2) VALUES ('1',2), ('2',3), ('3',4);
INSERT INTO #LatinTable (col1, col2) VALUES ('1',9), ('2',8), ('3',7);

SELECT
A.[col1],
B.[col2]
FROM
[dbo].[Table1] A
JOIN
#LatinTable B ON A.[col1] = B.[col1]
GO

--meta ellenrzs
SELECT DATABASEPROPERTYEX(DB_NAME(), 'Collation')
SELECT DISTINCT
	ao.[name] AS [object_name],
	c.[collation_name],
	ao.type, ao.type_desc 
FROM 
	sys.columns c 
JOIN	
	sys.all_objects ao ON ao.[object_id] = c.[object_id]
WHERE
	c.[collation_name] IS NOT NULL
AND	
	ao.[type] IN ('U');

SELECT [name], [collation_name] FROM tempdb.sys.columns ao WHERE ao.[object_id] = (SELECT [object_id] FROM tempdb.sys.objects WHERE [name] LIKE '#LatinTable%')

/*cleanup*/
USE [master];
GO
IF DB_ID('ContainedDb') IS NOT NULL
	BEGIN
		ALTER DATABASE [ContainedDb] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
		DROP DATABASE [ContainedDb];
	END
GO
DROP TABLE #LatinTable;
GO